package mp3tools;
import java.nio.BufferUnderflowException;
import java.nio.ByteBuffer;

public class MP3Buffer {

	//MP3Buffer should use the buffer class. ByteBuffer.
	/*
	 * Tasks:
	 * 
	 * 1) Be given a ByteBuffer or whatever to work with. Ideally it is actually a buffer
	 * 2) Uses the allocate thing to create an instance
	 * 3) Returns the nextframe, uses fancy parsing features to achieve this.
	 * 4) 
	 */
	private ByteBuffer backingBuffer;
	
	//Constructor
	public MP3Buffer(int length)
	{
		backingBuffer = ByteBuffer.allocate(length);
	}
	
	public byte[] array()
	{
		return backingBuffer.array();
	}
	
	public int position()
	{
		return backingBuffer.position();
	}
	
	public boolean hasRemaining()
	{
		return backingBuffer.hasRemaining();
	}
	
	public void position(int newpos)
	{
		backingBuffer.position(newpos);
	}
	
	public Frame getNextFrame() throws IllegalHeaderException
	{
		//Submit a header to header. Check if sync.
		boolean headerFound = false;
		byte[] frameData = new byte[0];
		do 
		{
			try
			{
			byte[] headerData = new byte[4];
			backingBuffer.get(headerData);
			//reset position
			backingBuffer.position(position()-4);
			Header myHeader;
			myHeader = new Header(headerData);
			if(myHeader.isHeader())
			{
				headerFound = true;
				frameData = new byte[myHeader.getFrameLength()];
				//Position should update...
				backingBuffer.get(frameData);
			}
			else
			{
				System.out.println(backingBuffer.position());
				//We want to increment...
				backingBuffer.position(backingBuffer.position()+1);
			}
			}
			catch (BufferUnderflowException e)
			{
				//There is less than a header left in the file, stop searching.
				//Advance position to end of file, and return an empty frame.
				backingBuffer.position(backingBuffer.capacity()-1);
				return new Frame(new byte[0]);
			}
		} while(!headerFound);
			
		return new Frame(frameData);
	}
	/*
	public static MP3Buffer allocate(int capacity)
	{
		return (MP3Buffer) ByteBuffer.allocate(capacity);
	}
	*/

}
